/*
 * sturmbahnfahrer
 * (c) 2006 by Bram Stolk
 * bram at gmail.com
 * LICENSED ACCORDING TO THE GPL
 */

#include <assert.h>
#include <math.h>
#include <errno.h>
#include <fcntl.h>

#include "controller.h"


ControllerKey::ControllerKey(void) :
Controller(),
key_steerl(false),
key_steerr(false),
key_accel(false),
key_brake(false),
key_action(false),
key_ebrake(false)
{
  name = "keyboard controller";
  axes[0]=axes[1]=axes[2]=0.0;
}


ControllerKey::~ControllerKey()
{
}


void ControllerKey::Sustain(float dt)
{
  axes[0] = 0.0;
  if (key_steerl) axes[0] -= 0.7;
  if (key_steerr) axes[0] += 0.7;
  axes[1] = (key_accel)?0.9:0.0;
  axes[2] = (key_brake)?0.9:0.0;
}


float ControllerKey::GetAxisValue(int nr) const
{
  assert(nr<3);
  return axes[nr];
}


bool ControllerKey::GetButtonValue(int nr) const
{
  if (nr == 0)
    return key_action;
  if (nr == 1)
    return key_ebrake;
  return false;
}

void ControllerKey::Feed(unsigned char k, bool down)
{
  if (k=='a') { key_accel = down; return; }
  if (k=='z') { key_brake = down; return; }
  if (k==',') { key_steerl = down; return; }
  if (k=='.') { key_steerr = down; return; }
  if (k==' ') { key_action = down; return; }
  if (k=='b') { key_ebrake = down; return; }
  if (k==9)   { key_ebrake = down; return; }
}



